//============================================================================
// Name        : vector_iterator.cpp
// Author      : 
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C++, Ansi-style
//============================================================================

#include <iostream>
#include <vector>
#include <list>
#include <cstdlib>
#include <algorithm>
#include <ostream>

using namespace std;

template<typename T>
void myrandomize(vector<T> &v)
{
	const int sz = v.size();

	for (int k=0; k<20; k++) {
		int i = rand() % sz;
		int j = rand() % sz;
		swap(v[i], v[j]);
	}
}

template<typename C>
void print_container(const C &myv)
{
	typename C::const_iterator i = myv.begin();

	for ( ; i != myv.end(); ++i)
		cout << *i << ", ";
	cout << endl;
}

class MyClass {
public:
	int i;
	MyClass() : i(0) {}
	explicit MyClass(int ii) : i(ii) {}
};

ostream & operator<<(ostream &o, const MyClass &obj)
{
	o << obj.i;
	return o;
}

class Cmp {
public:
	bool operator()(const MyClass &a, const MyClass &b)
	{
		if (a.i > b.i) return true;
		else return false;
	}
};


int main() {
	vector<int> myv;
	vector<int> v2;
	list<char> myl;

	vector<MyClass> list2;

	for (int i=0; i<10; i++)
		myv.push_back(i);

	for (int i=0; i<20; i++)
		v2.push_back(i);

	for (int i=0; i<15; i++)
		myl.push_back('a' + i);

	for (int i=0; i<15; i++)
		list2.push_back(MyClass(i));

	myrandomize(myv);
	myrandomize(v2);

	print_container(myv);
    print_container(v2);
    print_container(myl);
    print_container(list2);

    Cmp b;
    sort(myv.begin(), myv.end());

    sort(list2.begin(), list2.end(), b);

	print_container(myv);
	print_container(list2);

	return 0;
}
